# This file was auto-generated by ZETUP
#
# Zimmermann's Extensible Tools for Unified Project setups
#
# https://github.com/zimmermanncode/zetup


from __future__ import absolute_import

import sys
import os
from collections import OrderedDict

from zetup.version import Version
from zetup.dist import Distribution
from zetup.requires import Requirements
from zetup.extras import Extras
from zetup.package import Packages, Package
from zetup.notebook import Notebook



zfg = sys.modules[__name__]

NAME = 'moretools'

LICENSE = 'LGPLv3'

KEEP_MADE = ['setup.py']

SETUP_REQUIRES = Requirements("""

zetup[commands]
""", zfg=zfg)

SCRIPTS = None

VERSION = Version('0.1.11.dev14')

AUTHOR = 'Stefan Zimmermann'

TEST_COMMANDS = ['py.test -v test']

DESCRIPTION = 'MORE Overly Reusable Essentials for python'

CLASSIFIERS = ['Development Status :: 3 - Alpha', 'Intended Audience :: Developers', 'License :: OSI Approved :: GNU Library or Lesser General Public License (LGPL)', 'Operating System :: OS Independent', 'Topic :: Software Development', 'Topic :: Utilities', 'Programming Language :: Python', 'Programming Language :: Python :: 2', 'Programming Language :: Python :: 2.7', 'Programming Language :: Python :: 3', 'Programming Language :: Python :: 3.5', 'Programming Language :: Python :: 3.6', 'Programming Language :: Python :: 3.7']

EXTRAS = Extras([

], zfg=zfg)

MODULES = []

PYTHON = ['2.7', '3.5', '3.6', '3.7']

FORCE_MAKE = True

DISTRIBUTION = Distribution(zfg)

NO_MAKE = ['tox.ini']

in_repo = True

EMAIL = 'user@zimmermann.co'

URL = 'https://github.com/zimmermanncode/moretools'

PACKAGES = Packages([

Package('moretools',
  sources=[
    '_is.py',
    '_filter.py',
    '_star.py',
    '_xmlrpc.py',
    '_context.py',
    '_query.py',
    '_simpletree.py',
    '_types.py',
    '_undefined.py',
    '_tester.py',
    '_collections.py',
    '_common.py',
    '_operator.py',
    '_multidict.py',
    '_del.py',
    '_multi.py',
    '_log.py',
    '_has.py',
    '_caller.py',
    'func.py',
    '_cached.py',
    '_repeat.py',
    '_mapper.py',
    '_set.py',
    '_pop.py',
    '_operand.py',
    'boolean.py',
    '_take.py',
    '_dict.py',
    '_lazy.py',
    '_get.py',
    '_simpledict.py',
    '_empty.py',
    'mapping.py',
    '_multisimpledict.py',
    'test_func.py',
    '__init__.py',
    '_map.py',
    '_string.py'
    ],
  subpackages=[
    
    ],
  )

  ], root=os.path.dirname(os.path.dirname(os.path.realpath(__file__))))

SETUP_HOOKS = []

KEYWORDS = ['tools', 'itertools', 'functools', 'operator', 'collections', 'iterator', 'iteration', 'functional', 'filter', 'map', 'repeat', 'query', 'tuple', 'list', 'set', 'dict', 'simpledict', 'frozen', 'struct', 'dictset', 'dictzip', 'simpledictset', 'simpledictzip', 'camelize', 'decamelize', 'isidentifier', 'identifier', 'python3']

SETUP_KEYWORDS = None

TITLE = 'moretools'

REQUIRES = Requirements("""
zetup >= 0.2.58
six >= 1.12
decorator >= 4.4.0

""", zfg=zfg)